﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using Telerik.WinControls;
using Telerik.WinControls.UI;

namespace RadControlsExample
{
    public class MyMenuItem : RadMenuItem
    {
        private LightVisualElement numberElement;

        public LightVisualElement NumberElement
        {
            get { return numberElement; }
        }

        protected override void CreateChildElements()
        {
            base.CreateChildElements();

            this.numberElement = new LightVisualElement();
            this.numberElement.BindProperty(LightVisualElement.FontProperty, this, RadItem.FontProperty, PropertyBindingOptions.OneWay);
            this.Children.Add(this.numberElement);
        }

        public MyMenuItem(string text, int number)
            : base(text)
        {
            this.numberElement.Text = number.ToString();
        }

        protected override SizeF ArrangeOverride(SizeF finalSize)
        {
            SizeF size = base.ArrangeOverride(finalSize);

            float topBottomDistance = ((size.Height - this.numberElement.DesiredSize.Height) / 2f);
            float x = topBottomDistance / 2f + this.Padding.Left;
            float y = topBottomDistance / 2f + this.Padding.Top;
            RectangleF rect = new RectangleF(x, y, this.numberElement.DesiredSize.Width, this.numberElement.DesiredSize.Height);
            this.numberElement.Arrange(rect);

            return size;
        }

        protected override Type ThemeEffectiveType
        {
            get { return typeof(RadMenuItem); }
        }
    }
}
